#ifndef __LIBMPEG_H__

#define __LIBMPEG_H__



/*! very old code.

 *  \author Eric Sommerlade, end of 1998.

 */



#include "base.h"

#ifdef __cplusplus

extern "C" {

#endif



#include "mpeg2dec.h"



#ifdef WIN32

#define _libmpeg	__declspec( dllexport )

#else

#define _libmpeg

#endif





typedef enum echroma { 

  chroma420=CHROMA420, 

  chroma422=CHROMA422, 

  chroma444=CHROMA444 

} EChroma;



typedef struct {

  byte *Y,*Cr,*Cb;

} TPictureInfo;



typedef struct tstreaminfo {

  dword w,h,codedw; /* width, height & mpeg-encoded width (multiple of 16) */

  int aspect;

  double framerate;

  double bitrate;

  EChroma chroma; /* specifies chroma format */

  int bsFramenum; /* the frame number in the file */

  int sqFramenum; /* the frame number after reordering/sequence number */

  int bsFieldnum; /* the fieldnumber in the bitstream */

  bool endReached; /* end of bitstream reached; no more fields/frames */

  TPictureInfo curFrame; /* stores the data of current frame */



} TStreamInfo;



/** returns 0 if successful, 1 otherwise 

 */

int _libmpeg initializeDecoder(int argc, char *argv[]);

void _libmpeg deinitializeDecoder();



_libmpeg TStreamInfo*  initializeSequence();

void _libmpeg deinitializeSequence(TStreamInfo *stream);



/** returns the &(stream->curFrame) if successful, NULL otherwise 

 *  

 */

_libmpeg TPictureInfo* nextPicture(TStreamInfo *stream);

_libmpeg byte* toRGB(TStreamInfo *stream, TPictureInfo *pic);

  

#ifdef __cplusplus

}

#endif





#endif





