/***************************************************************************
                          io_jp2k.cpp  -  description
                             -------------------
    begin                : 08.04.2003
    copyright            : (C) 2003 by Fabian Wenzel
    email                : tuvisionlib@tuvision.de
	origin               : Maintainance

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/

#include <iostream>

#include <tuv/CImageByteGray.h>
#include <tuv/CException.h>
#include <tuv/CFileReadUtils.h>
#include <tuv/CFileWriteJpeg2k.h>
#include <tuv/CFileWritePng.h>

#include <cstdlib>


using namespace std;
using namespace TUVision;


int main (void)
{
    CImageByteRGB *origimage;
    CImageByteRGB *compressedimage;

    // Read "lena_orig.png" (RGB, 8 bit).
    try {
        origimage = readImageByteRGB("lena_orig.png");

        // Write "lena_compressed.jp2" with very low quality

        CFileWriteJpeg2k jp2kwriter;
        jp2kwriter.open("lena_compressed.jp2");

        // Quality is 0.1 %
        jp2kwriter.setQuality(0.001);
        jp2kwriter.write(*origimage);
        jp2kwriter.close();

        delete origimage;

        // Read "lena_compressed.jp2"

        compressedimage = readImageByteRGB("lena_compressed.jp2");

        CFileWritePng pngwriter;
        pngwriter.open("lena_compressed.png");
        pngwriter.write(*compressedimage);
        pngwriter.close();

        delete compressedimage;
    }
    catch (CException &e) { 
        cerr << "Error: " << e.what() << endl; 
        return EXIT_FAILURE; 
    } 

    return EXIT_SUCCESS;
}
