/***************************************************************************
                          CColourSpace.h  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 1002 by Eric Sommerlade
    email                : tuvisionlib@tuvision.de

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CCOLOURSPACE_H__
#define __TUVISION_CCOLOURSPACE_H__

#include "TUVisionDef.h"

namespace TUVision {

/*! encapsulates the interface to a linear colour space.
 * \class CColourSpace CColourSpace.h tuv/CColourSpace.h
 *
 *
 */

class CColourSpaceMatrix;

class _CCTUVISION CColourSpace {
public:
    virtual CColourSpaceMatrix getMatrixToXYZ() const=0;
    virtual CColourSpaceMatrix getMatrixFromXYZ() const=0;
};

} // namespace TUVision

#endif
