/***************************************************************************
                          CColourSpaceMatrix.h  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Eric Sommerlade
    email                : tuvisionlib@tuvision.de
    origin               : Studienarbeit/Diplomarbeit Eric Sommerlade

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CCOLOURSPACEMATRIX_H__
#define __TUVISION_CCOLOURSPACEMATRIX_H__

#include "TUVisionDef.h"

namespace TUVision {

class _CCTUVISION CColourSpaceMatrix {
public:
    CColourSpaceMatrix(int inchannels, int outchannels);
    ~CColourSpaceMatrix();

    /// multiplies two matrices. Must have appropriate dimensions!
    CColourSpaceMatrix& operator*=(const CColourSpaceMatrix& cm);


    /// returns the row vector to convert into one destination channel.
    const double* getChannelRow(int channel) const;

    /// sets the row vector for one destination channel.
    void setChannelRow(int channel, const double* coeffs);

private:
    int d_inchannels;
    int d_outchannels;
    double* d_data;
};

} // namespace

#endif
