/***************************************************************************
                          CException.h  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Marco Budde
    email                : tuvisionlib@tuvision.de
    origin               : Diplomarbeit Marco Budde

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CEXCEPTION_H__
#define __TUVISION_CEXCEPTION_H__ 1

#include <string>
#include "TUVisionDef.h"

namespace TUVision {

/**********************************************************/
//!  Base class defining an exception.
/*!
 *   This base class defines an exception. Most exceptions
 *   thrown by this library are derived from this class.
 *
 *   \ingroup exception
 *
 *   \author Marco Budde
 */
/**********************************************************/

class _CCTUVISION CException {

public:

    CException() {}
    CException(const std::string &what) : d_what(what) {}
    virtual ~CException() {}

    /******************************************************/
    //! Get a description of the problem.
    /******************************************************/
    virtual const std::string &what (void) const;

protected:
    std::string d_what;  //!< description of the problem
};

} // namespace TUVision

#endif // __TUVISION_CEXCEPTION_H__
