/***************************************************************************
                          CExceptionRange.h  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Marco Budde
    email                : tuvisionlib@tuvision.de
    origin               : Diplomarbeit Marco Budde
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CEXCEPTIONRANGE_H__
#define __TUVISION_CEXCEPTIONRANGE_H__ 1

#include <string>
#include "TUVisionDef.h"
#include "tuv/CException.h"

namespace TUVision {

/**********************************************************/
//!  Exception: range error
/*!
 *   This base class defines a range exception. It could
 *   be used to report underflows or overflows.
 *
 *   \ingroup exception
 *
 *   \author Marco Budde
 *   \author Eric Sommerlade
 */
/**********************************************************/

class _CCTUVISION CExceptionRange : public CException { 

public:

    /******************************************************/
    //! Constructor
    /******************************************************/
    CExceptionRange (const std::string &description,
        int spec_value, int valid_min, int valid_max);
};

} // namespace TUVision

#endif // __TUVISION_CEXCEPTIONRANGE_H__
