/***************************************************************************
                          CFileWriteBmp.h  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Islam Shdaifat
    email                : tuvisionlib@tuvision.de
    origin               : PhD - Thesis Islam Shdaifat

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CFILEWRITEBMP_H_
#define __TUVISION_CFILEWRITEBMP_H_ 1

#include <exception>

#include "TUVisionDef.h"
#include "tuv/CImageDatatypes.h"

#include "CFileWrite.h"
#include "CException.h"


namespace TUVision {


/**********************************************************/
/*! 
 *   This class saves an image as a BMP graphic file.
 *
 *   \ingroup io
 *
 *   \author Fabian Wenzel
 */
/**********************************************************/

class _CCTUVISION CFileWriteBmp: public CFileWrite {

public:
    CFileWriteBmp (void);
    ~CFileWriteBmp();

    void open (const std::string &filename)
        throw (CException);

    void close (void)
        throw();


    /******************************************************/
    //!  Save 8 bit gray image in BMP fornmat.
    /******************************************************/
    void write (const CImageByteGray &img)
        throw (CException);

    /******************************************************/
    //!  Save 8 bit RGB image BMP fornmat.
    /******************************************************/
    void write (const CImageByteRGB &img)
        throw (CException);
private:
    void *jfile;
};

}

#endif

