/***************************************************************************
                          CCannyFilter.h  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Islam Shdaifat
    email                : tuvisionlib@tuvision.de
    origin               : PhD - Thesis Islam Shdaifat

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
// CCannyFilter.h

#ifndef __TUVISION_CFILTERCANNY_H__
#define __TUVISION_CFILTERCANNY_H__ 1

#include "TUVisionDef.h"
#include "tuv/CImageDatatypes.h" 

typedef struct image *IMAGE;

namespace TUVision 
{

/**********************************************************/
//!  Sobel filter (edge detection)
/*! 
 *   This class implements the Canny filter used for
 *   edge detection.
 *
 *   \ingroup filter
 *
 *   \author Islam Shdaifat
 */
/**********************************************************/
class _CCTUVISION CCannyFilter  
{
public:
    CCannyFilter(float s_in = 0.7, int low_in = 5, int high_in = 5);
    virtual ~CCannyFilter();
    void filter (CImageByteGray &img);
    void init(CImageByteGray &img, float s_in = 3 , int low_in = 3, int high_in = 5);

private:
    IMAGE newCannyImage(CImageByteGray& img, bool cpy = true);
    void freeCannyImage (struct image  *z);
    void copyCannyImageTo(CImageByteGray& img, IMAGE x);
    void copyImageToCanny(CImageByteGray& img, IMAGE x);

    float s; // standard deviation
    int low ,high ; // low edge and high edge
    IMAGE im, magim, oriim;

};
} 

#endif // __TUVISION_CFILTERCANNY_H__
