/***************************************************************************
                          CCurve.h  -  description
                             -------------------
    begin                : 1.1.2000
    copyright            : (C) 2000 by Islam Shdaifat
    email                : tuvisionlib@tuvision.de
    origin               : PhD - Thesis Islam Shdaifat
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
//CCurve.h
#ifndef __TUVISION_CCURVE_H_
#define __TUVISION_CCURVE_H_ 1

#include "tuv2d/CPointXY.h"

#include "TUVisionDef.h"
#include "tuv/CImageDatatypes.h"

#include <vector>

namespace TUVision 
{

class CPointXY;

/**********************************************************/
/*! 
 *    This base class defines a curve and it's proparities.
 *    The curve is a vector of points (CPointXY).
 *
 *    \author Islam Shdaifat
 */
/**********************************************************/
class _CCTUVISION CCurve {

public:


    void getCurveFromImage( const CImageByteGray &img);//! gets curve from binary image

    std::vector < CPointXY > vecCurvePoints; //! a vector of curve points
    int CurveLength;           //! the curve length
    CPointXY CurveEndPoint;    //! the curve end point
    CPointXY CurveStartPoint;  //! the curve start point
    CPointXY CurveOrigin;      //! the curve origin 
    double attribute;          //! an attribute e.g. for line slope
    double parameters[10];     //! to store curve parameters e.g. focal point, major minor axes etc..
};

} // TUVision

#endif  // __TUVISION_CCURVE_H_
