/***************************************************************************
                          CExtractorCentroid.h  -  description
                             -------------------
    begin                : 10.04.2001
    copyright            : (C) 2001 by Fabian Wenzel
    email                : tuvisionlib@tuvision.de, f.wenzel@gmx.net
    origin               : Diplomarbeit Fabian Wenzel

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/

#ifndef __TUVISION_CEXTRACTORCENTROID_H__
#define __TUVISION_CEXTRACTORCENTROID_H__ 1

#include "tuv/CVertex.h"
#include "tuv/CImageByteGray.h"

namespace TUVision{

/**********************************************************/ 
//!  Calculates the centroid (the center of gravity) for a gray image
/*! 
 *   For regions in an image the function CImage::SetWindow() has to be
 *   called first. As the centroid does not have to be integer type, the
 *   result is returned as a double 2D - vector.
 *
 *   \ingroup extractors
 *
 *   \author Fabian Wenzel
 */
class _CCTUVISION CExtractorCentroid{
public:
    CExtractorCentroid();
    static CVertex2d *calcCentroid(const CImageByteGray *img);
};
}
#endif
