/***************************************************************************
                          CFilterDoubleGray.h  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Marco Budde
    email                : tuvisionlib@tuvision.de
    origin               : Diplomarbeit Marco Budde

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_CFILTERDOUBLEGRAY_H__
#define __TUVISION_CFILTERDOUBLEGRAY_H__ 1

#include "TUVisionDef.h"
#include "tuv/CImageDatatypes.h"


namespace TUVision 
{

/**********************************************************/
//!  A generic filter for double gray level images.
/*! 
 *   This base class defines a generic image filter for
 *   double gray level images. 
 *
 *   The real filtering takes place in the filter()
 *   function. This function has to be implemented in
 *   the derived filter classes. A filtered image has got
 *   always the same properties (i.e. width, height,
 *   number format, and color model) as the source image.
 *
 *   \ingroup filter
 *
 *   \author Marco Budde
 */
/**********************************************************/

class _CCTUVISION CFilterDoubleGray {

public:
    virtual ~CFilterDoubleGray() {};

    /******************************************************/
    //! Filter the image (double gray level).
    /******************************************************/
    virtual void filter (CImageDoubleGray &img) =0;  
};

}

#endif // __TUVISION_CFILTERDOUBLEGRAY_H__

