/***************************************************************************
                          COperatorGray.h  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Marco Budde
    email                : tuvisionlib@tuvision.de
    origin               : Diplomarbeit Marco Budde

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_COPERATORGRAY_H__
#define __TUVISION_COPERATORGRAY_H__ 1

#include "TUVisionDef.h"
#include "tuv/CImageDatatypes.h"

namespace TUVision {

/*! \file COperatorGray.h
 *  This file groups all overloaded operators for gray images.
 *
 *  \author Eric Sommerlade
 */

//! subtracts byte images pixel-wise.
CImageIntGray _CCTUVISION operator- (const CImageByteGray &lhs, 
    const CImageByteGray &rhs);

//! subtracts int images pixel-wise.
CImageIntGray _CCTUVISION operator- (const CImageIntGray &lhs, 
    const CImageIntGray &rhs);

} // namespace TUVision


#endif // __TUVISION_COPERATORGRAY_H__
