/***************************************************************************
                          COperatorRGB.h  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Marco Budde
    email                : tuvisionlib@tuvision.de
    origin               : Diplomarbeit Marco Budde

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#ifndef __TUVISION_COPERATORRGB_H__
#define __TUVISION_COPERATORRGB_H__ 1

#include "TUVisionDef.h"
#include "tuv/CImageDatatypes.h"

namespace TUVision {

/*! \file COperatorRGB.h
 *  This file groups all overloaded operators for rgb images.
 *  
 *  It also keeps conversion operators to Gray images.
 *  \author Eric Sommerlade
 */

//! converts a rgb image to gray.
CImageByteGray _CCTUVISION
    convertToGray (const CImageByteRGB &rgb);

//! converts a yuv image to (default) rgb.
CImageByteRGB _CCTUVISION
    convertToRGB (const CImageByteYUV &yuv);

//! converts a gray image to (default) rgb.
CImageByteRGB _CCTUVISION 
    convertToRGB (const CImageByteGray &gray);


} // namespace TUVision


#endif // __TUVISION_COPERATORRGB_H__
