/***************************************************************************
                          CColourSpaceRGB.cpp  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Eric Sommerlade
    email                : tuvisionlib@tuvision.de
    origin               : Studienarbeit/Diplomarbeit Eric Sommerlade

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#include "tuv/CColourSpaceRGB.h"
#include "tuv/CColourSpaceMatrix.h"

using namespace TUVision;

static int s_instances=0;
static CColourSpaceRGB* s_instance;

static CColourSpaceMatrix* s_xyz_to_rgb_matrix;
static CColourSpaceMatrix* s_rgb_to_xyz_matrix;


CColourSpaceRGB&
CColourSpaceRGB::getColorSpaceRGB() 
{
    if(s_instances==0) {
        s_instance=new CColourSpaceRGB();
    }
    s_instances++;
    return *s_instance;
}

CColourSpaceRGB::~CColourSpaceRGB()
{
    s_instances--;

    ///  if(s_instances==0) {
    ///    delete matrix or whatever static data members...
}


CColourSpaceRGB::CColourSpaceRGB()
{
    // set up static data members...
}

CColourSpaceMatrix 
CColourSpaceRGB::getMatrixToXYZ() const
{
    return CColourSpaceMatrix(*s_rgb_to_xyz_matrix);
}

CColourSpaceMatrix 
CColourSpaceRGB::getMatrixFromXYZ() const
{
    return CColourSpaceMatrix(*s_xyz_to_rgb_matrix);
}
