/***************************************************************************
                          CExceptionRange.cpp  -  description
                             -------------------
    begin                : 01.01.2001
    copyright            : (C) 2001 by Marco Budde
    email                : tuvisionlib@tuvision.de
    origin               : Diplomarbeit Marco Budde

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#include <cstdio>  // fixme: use stringstream instead

#include "tuv/CException.h"
#include "tuv/CExceptionRange.h"

using namespace std;
using namespace TUVision;



/**********************************************************/
/*! 
 *   Constructs the exception. The created message looks
 *   like the following: "(description) The specified 
 *   value of (spec_value) is not in the range of allowed
 *   values ((valid_min)-(valid_max))." 
 *
 *   \param description description
 *   \param spec_value  the wrong value specified by the
 *                      user
 *   \param valid_min smallest allowed value
 *   \param valid_max largest allowed value
 *
 *   \bug Should use stringstream (not supported by gcc).
 */
/**********************************************************/

CExceptionRange::CExceptionRange (const std::string &description,
                                  int spec_value, int valid_min,
                                  int valid_max)
{
    char msg[1000];


    sprintf (msg, " The specified value of \"%i\" is not in the "
        "range of allowed values (%i-%i).", spec_value,
        valid_min, valid_max);          

    d_what = description;
    d_what += msg;
}

