/***************************************************************************
                          CParabola.cpp  -  description
                             -------------------
    begin                : 1.1.2000
    copyright            : (C) 2000 by Islam Shdaifat
    email                : tuvisionlib@tuvision.de
    origin               : PhD - Thesis Islam Shdaifat
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#include "tuv2d/CParabola.h"
using namespace TUVision;
void
CParabola::setParabola(int w, int h, int x_direction) {

    d_w=w; d_h=h;
    // this curve is stored here in the LUT
    // the equation is y=d*x*x the rectangle in which we search
    // is w*l l-->y   w-->x
    int x, y, CurveLength=0;
    for(int Y=1;Y<h;Y++) // for y starts at 1 up to h
    {
        CurveLength=0;
        double d=(double)Y/(double)(w*w);  //y=d x^2
        int tmp=0;

        for(x=0 ; x<=w ; x++)
        {
            double yt=d*(double) (x*x);
            y=(int) rint(yt); //y=d*x^2
            if(abs(y-tmp) >1) // if a space i.e. a jump swich to the other coordinate
                break;
            tmp=y;
            d_Pxy.x = x*x_direction;// ::cout<<x<<"x "; //store this point in the curve
            d_Pxy.y = y;// ::cout<<y<<"y ,";
            d_Cxy.vecCurvePoints.push_back(d_Pxy); // add a point to the curve
            CurveLength++; // increase the length of the curve
        }//end for x
        int y1=tmp;
        for (y= tmp+1 ; y<h ;y++){
            double xt=sqrt((double)y/d);
            x=(int) rint(xt);
            if (x>w)
                break;
            d_Pxy.x = x*x_direction;// ::cout<<x<<"x ";
            d_Pxy.y = y;// ::cout<<y<<"y ,";
            d_Cxy.vecCurvePoints.push_back(d_Pxy); // add a point to the curve
            CurveLength++;
        }//end for y
        d_Cxy.CurveLength=CurveLength; // set the curve length
        //		d_Cxy.Thr0 = m_rTh0*double(CurveLength); // the Thr0
        //		d_Cxy.Thr1 = m_rTh1*double(CurveLength); // the Thr1
        vecCurvesLUT.push_back(d_Cxy); // add the curve to LUT
        d_Cxy.vecCurvePoints.clear();
    }// end for Y	
    for(int X=w;X>0;X--)
    {
        CurveLength=0;
        double d=(double)w /(double)(X*X);
        int tmp=0;
        for(x=0 ; x<=w ; x++)
        {
            double yt=d*(double)(x*x);
            y=(int) rint(yt); //y=d*x^2
            if(abs(y-tmp) >1)
                break;
            tmp=y;
            d_Pxy.x = x*x_direction;// ::cout<<x<<"x ";
            d_Pxy.y = y;// ::cout<<y<<"y ,";
            d_Cxy.vecCurvePoints.push_back(d_Pxy); // add a point to the curve
            CurveLength++;
        }//end for x
        int y1=tmp;
        for (y= tmp+1 ; y<h ;y++){
            double xt=sqrt((double)y/d);
            x=(int) rint(xt);
            if (x>w)
                break;
            d_Pxy.x = x*x_direction;// ::cout<<x<<"x ";
            d_Pxy.y = y;// ::cout<<y<<"y ,";
            d_Cxy.vecCurvePoints.push_back(d_Pxy); // add a point to the curve
            CurveLength++;
        }//end for y
        d_Cxy.CurveLength=CurveLength; // set the curve length
        d_Cxy.CurveEndPoint = d_Pxy;  // set the curve end point

        //		d_Cxy.Thr0 = m_rTh0*double(CurveLength); // the Thr0
        //		d_Cxy.Thr1 = m_rTh1*double(CurveLength); // the Thr1
        vecCurvesLUT.push_back(d_Cxy); // add the curve to LUT
        d_Cxy.vecCurvePoints.clear();
    }// end for X	
    getRidOfDuplicatedCurves();
}

/// construct a Parabola object with heignt h and width w
CParabola::CParabola(int w,int h,int x_direction , double thr0 , double thr1)
{
    m_rTh0=thr0;
    m_rTh1=thr1;
    setParabola(w,h,x_direction);
}

/**
 * This function search In the given InImage a parabola which 
 * should be on of the pattern inside the ParabolaLUT.
 */
int 
CParabola::isParabola(CPointXY &st, CPointXY &en,
                      unsigned char *InImage,
                      unsigned char *OutImage,
                      int x_size, int y_size,
                      int& w,int& Thr0,int& Thr1, int del)
{	
    return 0;
}
