/***************************************************************************
                          CPointXY.cpp  -  description
                             -------------------
    begin                : 1.1.2000
    copyright            : (C) 2000 by Islam Shdaifat
    email                : tuvisionlib@tuvision.de
    origin               : PhD - Thesis Islam Shdaifat
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/
#include "tuv2d/CPointXY.h"
#include <cmath>
#include <cstdlib>
using namespace TUVision;

CPointXY&
CPointXY::operator +(const CPointXY& otherPt )
{
    x+= otherPt.x;
    y+= otherPt.y;
    return *this;
}

CPointXY&
CPointXY::operator +=(const CPointXY& otherPt )
{
    x+= otherPt.x;
    y+= otherPt.y;
    return *this;
}

bool
CPointXY::operator ==(const CPointXY& otherPt )
{
    if(x == otherPt.x && y == otherPt.y)
        return true;
    return false;
}

bool 
CPointXY::isNear(const CPointXY& otherPt, const int dx, const int dy)
{
    if( abs(x - otherPt.x) <=dx && abs(y - otherPt.y) <= dy)
        return true;
    return false;
}
