/***************************************************************************
                           COperatorInvert.cpp  -  description
                              -------------------
     begin                : 22.08.2002
     copyright            : (C) 2002 Marc Hensel
     email                : tuvisionlib@tuvision.de, marc.hensel@web.de
     origin               : Diploma thesis Marc Hensel
 
***************************************************************************/


/***************************************************************************
 *                                                                         *
 *   This file is part of the TUVision Library. It is free software; you   *
 *   can redistribute it and/or modify it under the terms of the           *
 *   GNU Library General Public License as published by the Free Software  *
 *   Foundation; either version 2 of the License, or (at your option)      *
 *   any later version.                                                    *
 *                                                                         *
 ***************************************************************************/


#include <tuv2d/COperatorInvert.h>
#include <tuv/CImageByteGray.h>

// using namespace std;
using namespace TUVision;


/**************************************************
 *
 * Constructor and destructor
 *
 **************************************************/

COperatorInvert::COperatorInvert()
{
}


COperatorInvert::~COperatorInvert()
{
}


/**************************************************
 *
 * Public methods
 *
 **************************************************/

void COperatorInvert::invertImage(CImageByteGray *img)
{
    int				N;					//!< Number of pixel in image
    int				i;					//!< Current position in image array
    unsigned char	*row;				//!< Pointer: 1st pixel in row (image array)

    row	= img->getRow(0);
    N	= img->getW() * img->getH();

    /* Invert image */
    for (i=0; i<N; i++)
        row[i] = 255 - row[i];
}


